;##########################################################################
.386
.mmx
.model flat, stdcall
option casemap:none
title tross
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\gdi32.inc
include C:\masm32\include\ddraw.inc
include C:\masm32\include\ole32.inc
include C:\masm32\include\oleaut32.inc
include lib\ddraw.inc
;include lib\minifmod.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\gdi32.lib
includelib C:\masm32\lib\ddraw.lib
includelib C:\masm32\lib\ole32.lib
includelib C:\masm32\lib\oleaut32.lib
includelib C:\masm32\lib\winmm.lib
includelib lib\minifmod.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
comcall MACRO procedure, object, reg, parameters:VARARG
	LOCAL param, reversed
	reversed TEXTEQU <>
	mov	reg, [object]
%	for	param, <parameters>
		reversed CATSTR <param>, <!,>, reversed
	endm
%	for	param, <reversed>
		push	param
	endm
	push	reg
	mov	reg, [reg]
	call	[reg][procedure]
ENDM
ccall MACRO procedure, parameters:VARARG
	LOCAL param, reversed, paramcount
	reversed TEXTEQU <>
%	for	param, <parameters>
		reversed CATSTR <param>, <!,>, reversed
	endm
	paramcount = 0
%	for	param, <reversed>
		push	param
		paramcount = paramcount + 1
	endm
	call	procedure
	add	esp, paramcount*04h
ENDM
;##########################################################################
IID struct
	Data1	dd	?
	Data2	dw	?
	Data3	dw	?
	Data4	db	8 dup (?)
IID ends
IStream struc
	; IUnknown interface
	QueryInterface		dd	?	; pointer to interface ID/GUID, pointer to interface pointer
	AddRef			dd	?
	Release			dd	?
	; ISequentialStream interface
	Read			dd	?
	Write			dd	?
	; IStream interface
	Seek			dd	?
	SetSize			dd	?
	Commit			dd	?
	Revert			dd	?
	LockRegion		dd	?
	UnlockRegion		dd	?
	Stat			dd	?
	Clone			dd	?
IStream ends
IPicture struc
	; IUnknown interface
	QueryInterface		dd	?	; pointer to interface ID/GUID, pointer to interface pointer
	AddRef			dd	?
	Release			dd	?
	; IPicture interface
	get_Handle		dd	?	; pointer to GDI handle
	get_hPal		dd	?	; pointer to palette handle
	get_Type		dd	?	; pointer to type
	get_Width		dd	?	; pointer to width (himetric)
	get_Height		dd	?	; pointer to height (himetric)
	Render			dd	?	; hDC, x, y, width, height, src_x (himetric), src_y (himetric), src_width (himetric), src_height (himetric), pointer to metafile hDC rectangle
	set_hPal		dd	?	; pointer to palette handle
	get_CurDC		dd	?	; pointer to hDC
	SelectPicture		dd	?	; new hDC, pointer to previous hDC, pointer to GDI handle
	get_KeepOriginalFormat	dd	?	; pointer to value
	put_KeepOriginalFormat	dd	?	; new value
	PictureChanged		dd	?
	SaveAsFile		dd	?	; pointer to stream, bSaveInMemory, pointer to bytes written
	get_Attributes		dd	?	; pointer to attributes
IPicture ends
POINT3D struct
	x	dd	?
	y	dd	?
	z	dd	?
POINT3D ends	; 12 bytes
MEMFILE struc	; minifmod MEMFILE
	datalen	dd	?
	pos	dd	?
	data	dd	?
MEMFILE ends	; 12 bytes
;##########################################################################
	hExStyle	equ			WS_EX_TOPMOST
	hStyle		equ			WS_POPUP

	clrBack		equ			00212831h

	resWidth	equ			640
	resHeight	equ			480
	resBits		equ			32
	resSize		equ			resWidth * resHeight * resBits shr 3
	scanline	equ			resWidth * resBits shr 3

	logoWidth	equ			610
	logoHeight	equ			170
	logoSinSize	equ			47	; 47 = logofreq*pi*2

	bobWidth	equ			24
	bobHeight	equ			24
	bobLine		equ			bobWidth * resBits shr 3
	bobSize		equ			bobWidth * bobHeight * resBits shr 3
	bobCount	equ			39

	textLeft	equ			016
	textTop		equ			200
	textWidth	equ			200
	textHeight	equ			256
	textLine	equ			textWidth * resBits shr 3
	textSize	equ			textWidth * textHeight * resBits shr 3

	pageTime	equ			10000

	CurDate		TEXTEQU			<">, @Date, <">
	CurTime		TEXTEQU			<">, @Time, <">
	CurFileName	TEXTEQU			<">, @FileCur, <">
;##########################################################################
WndProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
init		PROTO
nextFrame	PROTO
shrink		PROTO
rect		PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fillrect	PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
darkrect	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
text		PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
DrawMonoBitmap	PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
sortBobs	PROTO
drawBobs	PROTO
initCircle	PROTO
rotate		PROTO
morph		PROTO
drawBob		PROTO
memopen		PROTO C	:DWORD
memclose	PROTO C	:DWORD
memread		PROTO C	:DWORD,:DWORD,:DWORD
memseek		PROTO C	:DWORD,:DWORD,:DWORD
memtell		PROTO C	:DWORD
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD 
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szAppTitle	db			"Template", 0
	szAppClass	db			"TEMPLATE32", 0
	szMsgAbout	db			"Template", 13, 10
			db			"Built on ", CurDate, " ", CurTime, 13, 10
			db			"Version 1.0", 0
	szMenuAbout	db			"&About Template...", 0
	szError		db			"Error", 0
	szErrorThread	db			"Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 0
	szErrorFinal	db			"Error at %08Xh", 13, 10, "Quitting...", 0

	;szFramesFormat	db			"%lu fps", 0

	;szPageOne	db			10
	;		db			"********************", 10
	;		db			01h, 04h, 02h, 03h, "c", 01h, 07h, 02h, 03h, "o", 03h, 02h, 01h, 04h, "mr", 01, 03h, 02h, 03h, "a", 03h, 02h, 01h, 04h, "d", 01h, 0Ch, 02h, 03h, "e", 03h, 02h, 03h, 02h, 01h, 00h, " ownz", 10
	;		db			"page one!", 10
	;		db			"********************", 0
	;szPageTwo	db			10
	;		db			"********************", 10
	;		db			"page two!", 10
	;		db			"********************", 0
	;szPageThree	db			10
	;		db			"********************", 10
	;		db			"page three!", 10
	;		db			"********************", 0
	;szPageFour	db			10
	;		db			"********************", 10
	;		db			"page four!", 10
	;		db			"********************", 0
	;pages		dd			OFFSET szPageOne, OFFSET szPageTwo, OFFSET szPageThree, OFFSET szPageFour, 0
	dwPages		dd			0041C000h
	

	IID_IPicture	dd			7BF80980h
			dw			0BF32h
			dw			0101Ah
			db			08Bh,0BBh,000h,0AAh,000h,030h,00Ch,0ABh


	;pal4		dw			0FFFFh, 00000h, 0000Fh, 003E0h, 0F800h, 07800h, 0780Fh, 0FBE0h, 0FFE0h, 007E0h, 003EFh, 007FFh, 0001Fh, 0F81Fh, 039E7h, 07BEFh
	pal4		dd			00FFFFFFh, 00000000h, 0000007Fh, 00007F00h, 00FF0000h, 007F0000h, 007F007Fh, 00FF7F00h, 00FFFF00h, 0000FF00h, 00007F7Fh, 0000FFFFh, 000000FFh, 00FF00FFh, 003F3F3Fh, 007F7F7Fh

	lens		real4			00256.00
	dpi		real8			6.283185307179586476925286766559
	fixedpoint	real4			65536.00
	logofreq	real4			00007.50
	logoamp		real4			00003.75
	c_div		real4			00039.00
	c_radius	real4			00137.50
	sum_div		dd			4

	include res\bob.inc
	include res\tross.inc
	include res\music.inc
	include res\logo-jpg.inc
	include res\fonts.inc

	EXTRN FSOUND_File_SetCallbacks:PROC
	EXTRN FSOUND_Init:PROC
	EXTRN FMUSIC_LoadSong:PROC
	EXTRN FMUSIC_PlaySong:PROC
	EXTRN FMUSIC_FreeSong:PROC
	EXTRN FSOUND_Close:PROC
;##########################################################################
.data
	wc		WNDCLASSEX		<sizeof WNDCLASSEX, CS_HREDRAW OR CS_VREDRAW, OFFSET WndProc, 0, 0, 0, 0, 0, 0, 0, OFFSET szAppClass, 0>
;##########################################################################
.data?
	hBackMemory	dd			?
	dwBack		dd			?
	dwPrev		dd			?
	dwText		dd			?
	hMemoryLogo	dd			?
	hStream		dd			?
	hPicLogo	dd			?
	hBmpLogo	dd			?
	hModule		dd			?
	szMessage	db			256 dup (?)
	dwTime		dd			?
	seh		dd			?

	msg		MSG			<>
	data_start	equ			$
	mbp		MSGBOXPARAMS		<>
	ddMain		LPDIRECTDRAW		?
	ddsPrimary	LPDIRECTDRAWSURFACE	?
	ddsd		DDSURFACEDESC		<>
	bmpLogo		BITMAP			<>
	memfile		MEMFILE			<>

	dwDrawBob	dd			?

	bob		db			bobSize dup (?)
	bobMask		db			bobSize dup (?)
	circle		POINT3D			bobCount dup (<>)
	morphed		POINT3D			bobCount dup (<>)
	logosin		dd			logoSinSize dup (?)
	sin		dd			256 dup (?)
	cos		dd			256 dup (?)
	sin_rot		dd			?
	cos_rot		dd			?
	angle		dd			?
	frames		dd			?
	x		dd			?
	y		dd			?
	z		dd			?
	sx		dd			?
	sy		dd			?
	morph_pos	dd			?	; 0
	morph_step	dd			?	; 1
	morph_wait	dd			?	; 128
	dwStack		dd			?
	dwFont		dd			?
	dwFontColour	dd			?
	dwPage		dd			?
	dwPageTime	dd			?
	bBold		db			?
	bUnderline	db			?
	bTextAlpha	db			?
	data_size	equ			$ - data_start
;##########################################################################
.code
start:	;invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	invoke	GetModuleHandle, 0
	xor	ecx, ecx
	mov	[wc.hInstance], eax
	mov	[mbp.hInstance], eax
	push	ecx
	push	eax
	push	ecx
	push	ecx
	push	ecx	; dwHeight
	push	ecx	; dwWidth
	push	ecx	; y
	push	ecx	; x

	invoke	ShowCursor, ecx
	invoke	RegisterClassEx, ADDR wc

	push	hStyle
	push	OFFSET szAppTitle
	push	OFFSET szAppClass
	push	hExStyle

	call	CreateWindowEx	;invoke	CreateWindowEx, hExStyle, ADDR szAppClass, ADDR szAppTitle, hStyle, ecx, eax, dwWidth, dwHeight, 0, [hMenu], [wc.hInstance], 0
	mov	[mbp.hwndOwner], eax
	push	eax
	invoke	ShowWindow, eax, SW_SHOWNORMAL
	call	UpdateWindow

	call	GetTickCount
	mov	[dwTime], eax

@@mlp:	xor	eax, eax
	invoke	PeekMessage, ADDR msg, eax, eax, eax, PM_NOREMOVE
	test	eax, eax
	.if !zero?
		xor	eax, eax
		invoke	GetMessage, ADDR msg, eax, eax, eax
		test	eax, eax
		jz	@@mend
		mov	eax, OFFSET msg
		push	eax
		invoke	TranslateMessage, eax
		call	DispatchMessage
	.else
		call	GetFocus
		.if eax==[mbp.hwndOwner]
		@@lksf:	mov	[ddsd.dwSize], sizeof DDSURFACEDESC
			mov	[ddsd.dwFlags], DDSD_PITCH
			ddsinvk	mLock, [ddsPrimary], 0, ADDR ddsd, DDLOCK_WAIT, 0
			cmp	eax, DDERR_SURFACELOST
			jne	@@nors
			ddsinvk	Restore, [ddsPrimary]
			jmp	@@lksf
		@@nors:	push	esi
			push	edi
			push	ebx
			;call	GetTickCount
			;sub	eax, [dwTime]
			;cmp	eax, 20
			;jb	@@noud
			;add	[dwTime], eax
			call	nextFrame
		@@noud:	ddinvk	WaitForVerticalBlank, [ddMain], DDWAITVB_BLOCKBEGIN, 0
			mov	esi, [dwBack]
			mov	edx, [ddsd.lpSurface]
			mov	ebx, resHeight
		@@blt:	mov	edi, edx
			mov	ecx, scanline shr 2
			rep	movsd
			add	edx, [ddsd.lPitch]
			dec	ebx
			jnz	@@blt
			pop	ebx
			pop	edi
			pop	esi
			ddsinvk	Unlock, [ddsPrimary], [ddsd.lpSurface]
		.else
			call	WaitMessage
		.endif
	.endif
	jmp	@@mlp
@@mend:	invoke	ExitProcess, eax
;#########################################################################
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_CREATE
		invoke	GlobalAlloc, GMEM_MOVEABLE, resSize+textSize
		mov	[hBackMemory], eax
		invoke	GlobalLock, eax
		mov	[dwBack], eax
		;add	eax, resSize
		;mov	[dwPrev], eax
		add	eax, resSize
		mov	[dwText], eax

		invoke	GetSystemMenu, [hWnd], 0
		push	OFFSET szMenuAbout
		push	10
		push	MFT_STRING
		push	eax
		invoke	AppendMenu, eax, MFT_SEPARATOR, 0, 0
		call	AppendMenu

		invoke	DirectDrawCreate, 0, ADDR ddMain, 0
		ddinvk	SetCooperativeLevel, [ddMain], [hWnd], DDSCL_EXCLUSIVE OR DDSCL_FULLSCREEN OR DDSCL_ALLOWREBOOT
		ddinvk	SetDisplayMode, [ddMain], resWidth, resHeight, resBits

		call	init

		mov	[ddsd.dwSize], sizeof ddsd
		mov	[ddsd.dwFlags], DDSD_CAPS
		mov	[ddsd.ddsCaps.dwCaps], DDSCAPS_PRIMARYSURFACE
		ddinvk	CreateSurface, [ddMain], ADDR ddsd, ADDR ddsPrimary, 0
	.elseif [uMsg]==WM_SYSCOMMAND && [wParam]==10
		mov	[mbp.cbSize], sizeof mbp
		mov	[mbp.lpszText], OFFSET szMsgAbout
		mov	[mbp.lpszCaption], OFFSET szAppTitle
		mov	[mbp.dwStyle], MB_OK OR MB_APPLMODAL OR MB_USERICON
		mov	[mbp.lpszIcon], 2
		invoke	MessageBoxIndirect, ADDR mbp
	.elseif [uMsg]==WM_KEYDOWN && [wParam]==VK_ESCAPE
		invoke	PostMessage, [hWnd], WM_CLOSE, 0, 0
	.elseif [uMsg]==WM_CLOSE
		comcall	[IPicture.Release], [hPicLogo], eax
		comcall	[IStream.Release], [hStream], eax
		mov	eax, [hMemoryLogo]
		push	eax
		invoke	GlobalUnlock, eax
		call	GlobalFree
		mov	eax, [hBackMemory]
		push	eax
		invoke	GlobalUnlock, eax
		call	GlobalFree

		push	[hModule]
		call	FMUSIC_FreeSong
		add	esp, 04h
		call	FSOUND_Close

		invoke	ShowCursor, 1

		ddinvk	RestoreDisplayMode, [ddMain]
		ddsinvk	Release, [ddsPrimary]
		ddinvk	Release, [ddMain]
	.elseif [uMsg]==WM_DESTROY
		invoke	PostQuitMessage, 0
		xor	eax, eax
		ret
	.endif
	pop	ebp
	jmp	DefWindowProc
WndProc endp
;#########################################################################
init proc
	invoke	GlobalAlloc, GMEM_MOVEABLE, jpgLogoSize
	mov	[hMemoryLogo], eax
	invoke	GlobalLock, eax
	push	esi
	push	edi
	mov	esi, OFFSET jpgLogo
	mov	edi, eax
	mov	ecx, jpgLogoSize shr 2
	rep	movsd
	mov	ecx, jpgLogoSize and 3
	rep	movsb
	pop	edi
	pop	esi
	invoke	GlobalUnlock, [hMemoryLogo]
	invoke	CreateStreamOnHGlobal, [hMemoryLogo], 1, ADDR hStream
	invoke	OleLoadPicture, [hStream], jpgLogoSize, 0, ADDR IID_IPicture, ADDR hPicLogo
	comcall	[IPicture.get_Handle], [hPicLogo], eax, OFFSET hBmpLogo
	invoke	GetObject, [hBmpLogo], sizeof bmpLogo, ADDR bmpLogo
	push	esi
	push	edi
	push	ebx
	; sine/cosine table generation
	mov	[y], ecx
	mov	eax, OFFSET sin
	mov	edx, OFFSET cos
	mov	ecx, 256
@@trig:	fild	[y]
	fmul	real8 ptr [dpi]
	fdiv	real4 ptr [lens]
	fsincos
	fmul	real4 ptr [fixedpoint]
	fistp	dword ptr [edx]
	fmul	real4 ptr [fixedpoint]
	fistp	dword ptr [eax]
	add	eax, 4
	add	edx, 4
	inc	[y]
	dec	ecx
	jnz	@@trig
	mov	[y], ecx
	mov	eax, OFFSET logosin
@@lgsn:	fild	[y]
	fdiv	[logofreq]
	fsin
	fmul	[logoamp]
	fistp	dword ptr [eax]
	inc	[y]
	add	eax, 4
	cmp	[y], logoSinSize
	jne	@@lgsn

	; binary bob into 32-bit bob
	mov	esi, OFFSET bBob + 64	; data
	mov	edi, OFFSET bob
	xor	edx, edx
@@b00:	movzx	eax, byte ptr [esi]
	mov	ecx, edx
	and	ecx, 00000001h
	xor	ecx, 00000001h
	shl	ecx, 2
	shr	eax, cl
	and	eax, 0000000Fh
	mov	eax, dword ptr [bBob][eax*4]
	stosd
	test	ecx, ecx
	jnz	@@b01
	inc	esi
@@b01:	inc	edx
	cmp	edx, bobWidth * bobHeight
	jne	@@b00

	; binary bob-mask into 32-bit bob-mask
	mov	esi, OFFSET bBobMask
	mov	edi, OFFSET bobMask
	xor	ecx, ecx
@@bm00:	mov	edx, ecx
	and	edx, 1Fh
	bt	dword ptr [esi], edx
	sbb	eax, eax
	stosd
	inc	ecx
	test	ecx, 1Fh
	jnz	@@bm01
	add	esi, 4
@@bm01:	cmp	ecx, bobWidth * bobHeight
	jne	@@bm00

	call	initCircle
	inc	[morph_step]
	mov	[morph_wait], 256
	;invoke	text, [dwText], 0, 0, ADDR szPage, textLine

	ccall	FSOUND_File_SetCallbacks, OFFSET memopen, OFFSET memclose, OFFSET memread, OFFSET memseek, OFFSET memtell
	ccall	FSOUND_Init, 44100, 0
	ccall	FMUSIC_LoadSong, OFFSET music, 0
	mov	[hModule], eax
	ccall	FMUSIC_PlaySong, eax

	; detect MMX
	xor	eax, eax
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], OFFSET @@safe
	mov	FS:[0], esp
	; critical code
	mov	[dwDrawBob], OFFSET drawBob
	pxor	MM0, MM0
	;mov	[dwDrawBob], OFFSET drawBob_mmx
@@safe:	pop	FS:[0]
	add	esp, 4
	pop	ebx
	pop	edi
	pop	esi
	ret
init endp
;#########################################################################
nextFrame proc
	push	esi
	push	edi
	push	ebx
	push	ebp
	inc	[frames]
	add	[angle], 4
@@chka:	cmp	[angle], 255
	jbe	@@a_ok
	sub	[angle], 256
	jmp	@@chka
@@a_ok:	mov	eax, [angle]
	mov	ecx, [sin][eax*4]
	mov	edx, [cos][eax*4]
	mov	[sin_rot], ecx
	mov	[cos_rot], edx

	dec	[morph_wait]
	jnz	@@m_ok
	inc	[morph_wait]
	mov	ecx, [morph_step]
	add	[morph_pos], ecx
	cmp	[morph_pos], 0
	jle	@@chms
	cmp	[morph_pos], 256
	jle	@@m_ok
@@chms:	neg	[morph_step]
	mov	[morph_wait], 256
@@m_ok:	

	mov	eax, 00312821h
	mov	edi, [dwBack]
	mov	ecx, resSize shr 2
	rep	stosd

	xor	ebx, ebx
	mov	esi, [bmpLogo.bmBits]
	mov	edx, [dwBack]
	add	edx, ((resWidth shr 1) - (logoWidth shr 1)) shl 2
@@ylog:	mov	ecx, logoWidth
	mov	eax, ebx
	add	eax, [frames]
@@lb00:	cmp	eax, logoSinSize
	jb	@@lb01
	sub	eax, logoSinSize
	jmp	@@lb00
@@lb01:	mov	eax, [logosin+eax*4]
	mov	edi, edx
	shl	eax, 2
	add	edi, eax
	@@xlog:	mov	eax, [esi]
		and	eax, 00FFFFFFh
		add	esi, 3
		stosd
		dec	ecx
		jnz	@@xlog
	inc	ebx
	add	esi, 2
	add	edx, scanline
	cmp	ebx, logoHeight
	jnz	@@ylog

	mov	esi, OFFSET circle
	mov	ebp, OFFSET tross
	mov	edi, OFFSET morphed
	push	edi
	call	morph
	mov	esi, [esp]
	mov	edi, [esp]
	call	rotate
	mov	edi, [esp]
	mov	ecx, bobCount
	call	sortBobs
	pop	esi
	call	drawBobs

	COMMENT %
	mov	esi, [dwText]
	mov	edi, [dwBack]
	mov	[y], textHeight
	add	edi, (textTop*scanline)+(textLeft*4)
@@txty:	mov	[x], textWidth
	@@txtx:	mov	eax, [esi]
		shr	eax, 3
		mov	ebx, [edi]
		shr	ebx, 3
		and	eax, 003F3F3Fh
		and	ebx, 003F3F3Fh
		lea	edx, [eax*4+eax]
		add	eax, eax
		add	eax, edx
		add	eax, ebx
		mov	[edi], eax
		add	esi, 4
		add	edi, 4
		dec	[x]
		jnz	@@txtx
	add	edi, scanline-textLine
	dec	[y]
	jnz	@@txty
	%
	invoke	darkrect, textLeft, textTop, textWidth, textHeight
	mov	eax, [dwPage]
	mov	edx, [dwPages]
	mov	eax, [edx][eax*4]
	invoke	text, [dwBack], textLeft, textTop, eax, scanline
	invoke	rect, textLeft, textTop, textWidth, textHeight, 00FFFFFFh

	call	shrink

	call	GetTickCount
	push	eax
	sub	eax, [dwTime]
	sub	eax, [dwPageTime]
	cmp	eax, pageTime
	jle	@@npg0
	add	[dwPageTime], eax
	inc	[dwPage]
	mov	eax, [dwPage]
	mov	edx, [dwPages]
	mov	eax, [edx][eax*4]
	test	eax, eax
	jnz	@@npg0
	and	[dwPage], 0
@@npg0:	pop	eax
	sub	eax, [dwTime]
	xor	edx, edx
	mov	ebx, [frames]
	mov	ecx, 1000
	div	ecx
	test	eax, eax
	.if !zero?
		xor	edx, edx
		xchg	eax, ebx
		div	ebx
	.endif
	;invoke	wsprintf, ADDR szMessage, ADDR szFramesFormat, eax
	;invoke	text, [dwBack], 0, 0, ADDR szMessage, scanline

	;test	[frames], 3
	;jnz	@@noup
	;mov	esi, [dwBack]
	;mov	edi, [dwPrev]
	;mov	ecx, resSize shr 2
	;rep	movsd
@@noup:	pop	ebp
	pop	ebx
	pop	edi
	pop	esi
	ret
nextFrame endp
;##########################################################################
shrink proc
	mov	[dwStack], esp
	mov	esi, [dwBack]
	mov	edi, [dwBack]
	mov	ebx, [dwBack]
	mov	ebp, [dwBack]
	mov	esp, [dwBack]
	add	edi, ((resHeight-060-16)*scanline) + ((resWidth-80-16)*4)
	add	ebx, ((resHeight-128-16)*scanline) + ((resWidth-80-16)*4)
	add	ebp, ((resHeight-196-16)*scanline) + ((resWidth-80-16)*4)
	add	esp, ((resHeight-264-16)*scanline) + ((resWidth-80-16)*4)
	mov	[y], 60
@@smy0:	mov	[x], 80
	@@smx0:	mov	[sy], 8
		@@smy1:	mov	[sx], 7
			mov	eax, [esi]
			add	esi, 4
			@@smx1:	shr	eax, 1
				mov	ecx, [esi]
				shr	ecx, 1
				and	eax, 007F7F7Fh
				and	ecx, 007F7F7Fh
				add	eax, ecx
				add	esi, 4
				dec	[sx]
				jnz	@@smx1
			add	esi, scanline-32
			dec	[sy]
			jnz	@@smy1
		sub	esi, scanline*8
		mov	edx, eax
		mov	ecx, eax
		and	edx, 000000FFh
		and	ecx, 0000FF00h
		and	eax, 00FF0000h
		shr	ecx, 8
		shr	eax, 16
		add	ecx, edx
		add	eax, ecx
		;xor	edx, edx
		;div	[sum_div]
		shr	eax, 2
		mov	[edi], eax
		shl	eax, 8
		mov	[ebx], eax
		shl	eax, 8
		mov	[ebp], eax
		or	eax, [edi]
		or	eax, [ebx]
		mov	[esp], eax

		add	esi, 32
		add	edi, 4
		add	ebx, 4
		add	ebp, 4
		add	esp, 4
		dec	[x]
		jnz	@@smx0
	add	esi, (scanline*8)-(32*80)
	add	edi, scanline-320
	add	ebx, scanline-320
	add	ebp, scanline-320
	add	esp, scanline-320
	dec	[y]
	jnz	@@smy0
	mov	esp, [dwStack]
	invoke	rect, resWidth-80-16, resHeight-060-16, 80, 60, 00FFFFFFh
	invoke	rect, resWidth-80-16, resHeight-128-16, 80, 60, 00FFFFFFh
	invoke	rect, resWidth-80-16, resHeight-196-16, 80, 60, 00FFFFFFh
	invoke	rect, resWidth-80-16, resHeight-264-16, 80, 60, 00FFFFFFh
	ret
shrink endp
;##########################################################################
rect proc dwX:DWORD, dwY:DWORD, dwWidth:DWORD, dwHeight:DWORD, dwColour:DWORD
	mov	eax, scanline
	mul	[dwY]
	mov	ecx, [dwX]
	mov	edx, [dwBack]
	lea	eax, [ecx*4+eax]
	add	edx, eax
	mov	ebx, [dwHeight]
	mov	eax, [dwColour]
	mov	edi, edx
	mov	ecx, [dwWidth]
	rep	stosd
	mov	ecx, [dwWidth]
	shl	ecx, 2
	sub	edi, 4
@@y01:	mov	[edi], eax
	add	edi, scanline
	dec	ebx
	jnz	@@y01
	sub	edi, ecx
	add	edi, 4
	mov	ebx, [dwHeight]
	mov	ecx, [dwWidth]
	rep	stosd
@@y02:	mov	[edx], eax
	add	edx, scanline
	dec	ebx
	jnz	@@y02
	ret
rect endp
;##########################################################################
fillrect proc dwX:DWORD, dwY:DWORD, dwWidth:DWORD, dwHeight:DWORD, dwColour:DWORD
	mov	eax, scanline
	mul	[dwY]
	mov	ecx, [dwX]
	mov	edx, [dwBack]
	lea	eax, [ecx*4+eax]
	add	edx, eax
	mov	ebx, [dwHeight]
	mov	eax, [dwColour]
@@y:	mov	edi, edx
	mov	ecx, [dwWidth]
	rep	stosd
	add	edx, scanline
	dec	ebx
	jnz	@@y
	ret
fillrect endp
;##########################################################################
darkrect proc dwX:DWORD, dwY:DWORD, dwWidth:DWORD, dwHeight:DWORD
	mov	eax, scanline
	mul	[dwY]
	mov	ecx, [dwX]
	mov	edx, [dwBack]
	lea	eax, [ecx*4+eax]
	add	edx, eax
	mov	ebx, [dwHeight]
@@y:	mov	edi, edx
	mov	ecx, [dwWidth]
	@@x:	mov	eax, [edi]
		shr	eax, 2
		and	eax, 003F3F3Fh
		mov	[edi], eax
		add	edi, 4
		dec	ecx
		jnz	@@x
	add	edx, scanline
	dec	ebx
	jnz	@@y
	ret
darkrect endp
;##########################################################################
text proc dwSurface:DWORD, dwX:DWORD, dwY:DWORD, dwString:DWORD, dwScanline:DWORD
	mov	[dwFont], OFFSET font
	mov	[dwFontColour], 00FFFFFFh
	mov	word ptr [bBold], 0

	mov	esi, [dwString]
	mov	eax, [dwX]
@@next:	xor	ecx, ecx
	mov	cl, byte ptr [esi]		; get character
	push	esi
	.if cl==01h				; colour
		mov	cl, byte ptr [esi+1]
		inc	dword ptr [esp]
		mov	ecx, [pal4+ecx*4]
		mov	[dwFontColour], ecx
		jmp	@@chk
	.elseif cl==02h
		xor	[bBold], 1
		mov	[dwFont], OFFSET font
		.if !zero?
			mov	[dwFont], OFFSET fontb
		.endif
		jmp	@@chk
	.elseif cl==03h				; underline
		xor	[bUnderline], 1
		jmp	@@chk
	.elseif cl==0Ah					; new line (centerred)
		push	dword ptr [bBold]		; save formatting options
		xor	ebx, ebx			; ebx = 0
		inc	esi				; esi = esi + 1
		xor	eax, eax			; eax = 0
		mov	edx, [dwFont]			; edx = font
	@@c000:	mov	bl, [esi]			; bl = character
		test	ebx, ebx			; see if ebx = 0
		jz	@@c00q				; if so, exit the loop
		cmp	ebx, 01h			; see if ebx = colour
		jne	@@c001				; if not, go to next check
		inc	esi				; increase esi by one
		jmp	@@c003				; jump to loop check point
	@@c001:	cmp	ebx, 02h			; see if ebx = bold
		jne	@@c002				; if not, go to next check
		xor	[bBold], 1			; switch fonts
		mov	edx, OFFSET font
		.if !zero?
			mov	edx, OFFSET fontb
		.endif
		jmp	@@c003				; jump to loop check point
	@@c002:	cmp	ebx, 03h			; see if ebx = underline
		je	@@c003				; if so, go to loop check point
		cmp	ebx, 10				; see if ebx = new line
		je	@@c00q				; if so, exit the loop
		mov	bl, [charset+ebx]		; translate character
		movsx	ecx, byte ptr [edx+ebx*2]	; get character width
		add	eax, ecx			; add it to total width
	@@c003:	inc	esi				; next character
		jmp	@@c000				; jump back to start of the loop
	@@c00q:	shr	eax, 1				; divide total width by 2
		pop	dword ptr [bBold]		; restore formatting options
		sub	eax, 100			; subtract 100 from total width
		neg	eax				; negate total width
		add	[dwY], 13			; add 13 to y
		add	eax, [dwX]			; center next position relative to x
		jmp	@@chk				; jump away
	.endif
	mov	esi, [dwFont]
	mov	cl, [charset+ecx]		; translate character
	add	ecx, ecx
	movzx	edx, byte ptr [esi+ecx]		; get character width
	movzx	ebx, byte ptr [esi+ecx+1]	; get character offset
	mov	ecx, eax
	lea	ebx, [esi+ebx+190]		; point esi to character offset
	push	edx				; save character width
	push	eax				; save character position
	invoke	DrawMonoBitmap, [dwSurface], ebx, ecx, [dwY], edx, 13, 120, [dwScanline], [dwFontColour]
	.if [bUnderline]
		mov	ebx, [esp]		; ebx = character position
		mov	edi, [dwSurface]	; edi = surface
		mov	eax, [dwScanline]	; eax = scanline width
		lea	edi, [edi+ebx*4]	; edi = edi + (character position * 4)
		mul	[dwY]			; eax = y * scanline width
		add	edi, eax		; edi = edi + eax
		mov	eax, 13
		mul	[dwScanline]		; eax = eax + (scanline width * 13)
		add	edi, eax
		mov	ecx, [esp+4]		; ecx = character width
		mov	eax, [dwFontColour]	; eax = font colour
		rep	stosd			; draw the underline
	.endif
	pop	eax				; restore next character position
	pop	edx				; restore character width
	add	eax, edx			; advance to next character
@@chk:	pop	esi
	inc	esi
	cmp	byte ptr [esi], 0
	jne	@@next
	ret
text endp
;##########################################################################
DrawMonoBitmap proc dwSurface:DWORD, bmp:DWORD, dwX:DWORD, dwY:DWORD, dwWidth:DWORD, dwHeight:DWORD, dwSrcScanline:DWORD, dwScanline:DWORD, dwColour:DWORD
	mov	eax, [dwScanline]
	mul	[dwY]
	mov	ecx, [dwX]
	mov	edx, [dwSurface]
	lea	eax, [ecx*4+eax]
	mov	esi, [bmp]
	add	edx, eax
	mov	ecx, [dwHeight]
@@y:	push	esi
	mov	edi, edx
	and	[x], 0
	mov	byte ptr [y], 128
	mov	ebx, [dwWidth]
	@@x:	mov	al, [esi]
		test	al, byte ptr [y]
		mov	eax, [dwColour]
		.if zero?
			mov	dword ptr [edi], eax
		.endif
		shr	byte ptr [y], 1
		inc	[x]
		xor	eax, eax
		cmp	[x], 8
		jb	@@nsa
		and	[x], 0
		inc	esi
		mov	byte ptr [y], 128
	@@nsa:	add	edi, 4
		dec	ebx
		jnz	@@x
	add	edx, [dwScanline]
	pop	esi
	add	esi, [dwSrcScanline]
	dec	ecx
	jnz	@@y
	ret
DrawMonoBitmap endp
;##########################################################################
sortBobs proc
@@001:	lea	eax, [ecx*8]
	lea	ebx, [edi+ecx*4]
	add	ebx, eax
	mov	eax, [edi][POINT3D.z]
@@002:	sub	ebx, sizeof POINT3D
	cmp	eax, [ebx][POINT3D.z]
	jle	@@003
	mov	eax, [edi][POINT3D.x]
	xchg	eax, [ebx][POINT3D.x]
	mov	[edi][POINT3D.x], eax
	mov	eax, [edi][POINT3D.y]
	xchg	eax, [ebx][POINT3D.y]
	mov	[edi][POINT3D.y], eax
	mov	eax, [edi][POINT3D.z]
	xchg	eax, [ebx][POINT3D.z]
	mov	[edi][POINT3D.z], eax
@@003:	cmp	ebx, edi
	jnz	@@002
	add	edi, sizeof POINT3D
	loopd	@@001
	ret
sortBobs endp
;##########################################################################
drawBobs proc
	push	esi
	push	edi
	push	ebx
	mov	ecx, bobCount
@@drcb:	push	ecx
	xor	edx, edx
	push	esi
	mov	eax, [esi][POINT3D.y]				; eax = y
	mov	ebx, 256					; ebx = 256
	shl	eax, 8						; 256*y
	sub	ebx, [esi][POINT3D.z]				; 256 - z
	cdq							; extend to qword
	idiv	ebx						; 256y/(256-z)
	add	eax, ((resHeight - 100) shr 1) - (bobHeight shr 1) + 100	; screen_y + height/2
	mov	ecx, scanline					; ecx = scanline
	mul	ecx						; result * scanline
	xor	edx, edx
	mov	ecx, eax					; ecx = screen_y
	mov	eax, [esi][POINT3D.x]				; eax = x
	shl	eax, 8						; 256*x
	cdq							; extended to qword
	idiv	ebx						; 256x/(256-z)
	add	eax, (resWidth shr 1) - (bobWidth shr 1)	; x + width/2
	lea	ecx, [eax*4+ecx]				; screen_y + (screen_x * 4)

	mov	esi, [dwBack]
	mov	edi, [dwBack]
	add	esi, ecx
	add	edi, ecx
	mov	ebx, OFFSET bob
	call	[dwDrawBob]

	pop	esi
	pop	ecx
	add	esi, sizeof POINT3D
	loopd	@@drcb
	pop	ebx
	pop	edi
	pop	esi
	ret
drawBobs endp
;##########################################################################
initCircle proc
	push	0
	mov	edi, OFFSET circle
	mov	ecx, bobCount
@@circ:	fild	dword ptr [esp]
	fmul	[dpi]
	fdiv	[c_div]
	fsincos
	fmul	[c_radius]
	fistp	[y]
	fmul	[c_radius]
	fistp	[x]

	mov	eax, [x]
	mov	ebx, [y]
	xor	edx, edx
	mov	[edi][POINT3D.x], eax
	mov	[edi][POINT3D.y], ebx
	mov	[edi][POINT3D.z], edx
	;mov	[edi+sizeof POINT3D][POINT3D.x], eax
	;mov	[edi+sizeof POINT3D][POINT3D.y], ebx
	;mov	[edi+sizeof POINT3D][POINT3D.z], edx
	add	edi, sizeof POINT3D

	inc	dword ptr [esp]
	loopd	@@circ
	pop	eax
	ret
initCircle endp
;##########################################################################
rotate proc
	push	ebp
	mov	ecx, bobCount
@@rot:	mov	eax, [esi][POINT3D.x]
	mov	ebx, [esi][POINT3D.y]
	mov	edx, [esi][POINT3D.z]
	mov	[x], eax
	mov	[y], ebx
	mov	[z], edx
	; rotation around X
	mov	eax, edx
	imul	[sin_rot]
	mov	ebx, eax
	mov	eax, [y]
	imul	[cos_rot]
	sub	eax, ebx
	sar	eax, 16
	mov	[edi][POINT3D.y], eax
	mov	eax, [z]
	imul	[cos_rot]
	mov	ebx, eax
	mov	eax, [y]
	imul	[sin_rot]
	add	eax, ebx
	sar	eax, 16
	mov	[edi][POINT3D.z], eax
	mov	[z], eax
	; rotation around Y
	mov	eax, [x]
	imul	[sin_rot]
	mov	ebx, eax
	mov	eax, [z]
	imul	[cos_rot]
	sub	eax, ebx
	sar	eax, 16
	mov	ebp, eax
	mov	eax, [x]
	imul	[cos_rot]
	mov	ebx, eax
	mov	eax, [z]
	imul	[sin_rot]
	add	eax, ebx
	sar	eax, 16
	mov	[edi][POINT3D.x], eax
	mov	[edi][POINT3D.z], ebp
	add	esi, sizeof POINT3D
	add	edi, sizeof POINT3D
	dec	ecx
	jnz	@@rot
	pop	ebp
	ret
rotate endp
;##########################################################################
morph proc
	mov	ecx, bobCount
@@mrph:	; x
	mov	eax, [esi][POINT3D.x]
	sub	eax, [ebp][POINT3D.x]
	imul	[morph_pos]
	sar	eax, 8
	add	eax, [ebp][POINT3D.x]
	mov	[edi][POINT3D.x], eax
	; y
	mov	eax, [esi][POINT3D.y]
	sub	eax, [ebp][POINT3D.y]
	imul	[morph_pos]
	sar	eax, 8
	add	eax, [ebp][POINT3D.y]
	mov	[edi][POINT3D.y], eax
	; z
	mov	eax, [esi][POINT3D.z]
	sub	eax, [ebp][POINT3D.z]
	imul	[morph_pos]
	sar	eax, 8
	add	eax, [ebp][POINT3D.z]
	mov	[edi][POINT3D.z], eax

	add	esi, sizeof POINT3D
	add	ebp, sizeof POINT3D
	add	edi, sizeof POINT3D
	loopd	@@mrph
	ret
morph endp
;##########################################################################
drawBob proc
	push	ebp
	mov	[dwStack], esp
	mov	[y], bobHeight
	mov	esp, OFFSET bobMask
@@y:	mov	ecx, bobWidth
	@@x:	mov	eax, [esi]
		mov	edx, [ebx]
		mov	ebp, [esp]
		and	edx, ebp
		not	ebp
		and	eax, ebp
		or	eax, edx
		mov	[edi], eax
		add	esi, 4
		add	esp, 4
		add	ebx, 4
		add	edi, 4
		dec	ecx
		jnz	@@x
	add	esi, scanline-bobLine
	add	edi, scanline-bobLine
	dec	[y]
	jnz	@@y
	mov	esp, [dwStack]
	pop	ebp
	ret
drawBob endp
;##########################################################################
memopen proc C pszName:DWORD
	mov	eax, OFFSET memfile
	mov	edx, [pszName]
	mov	[eax][MEMFILE.datalen], musicSize
	and	[eax][MEMFILE.pos], 0
	mov	[eax][MEMFILE.data], edx
	ret
memopen endp
;##########################################################################
memclose proc C handle:DWORD
	xor	eax, eax
	inc	eax
	ret
memclose endp
;##########################################################################
memread proc C lpData:DWORD, dwDataSize:DWORD, handle:DWORD
	mov	edx, [handle]
	push	esi
	push	edi
	mov	esi, [edx][MEMFILE.data]
	mov	edi, [lpData]
	add	esi, [edx][MEMFILE.pos]
	mov	ecx, [dwDataSize]
	shr	ecx, 2
	rep	movsd
	mov	ecx, [dwDataSize]
	and	ecx, 3
	rep	movsb
	mov	eax, [dwDataSize]
	pop	edi
	pop	esi
	add	[edx][MEMFILE.pos], eax
	ret
memread endp
;##########################################################################
memseek proc C handle:DWORD, pos:DWORD, mode:DWORD
	mov	eax, [pos]
	mov	ecx, [mode]
	mov	edx, [handle]
	.if ecx==SEEK_SET
		mov	[edx][MEMFILE.pos], eax
	.elseif ecx==SEEK_CUR
		add	[edx][MEMFILE.pos], eax
	.elseif ecx==SEEK_END
		add	eax, [edx][MEMFILE.datalen]
		mov	[edx][MEMFILE.pos], eax
	.endif
	ret
memseek endp
;##########################################################################
memtell proc C handle:DWORD
	mov	eax, [handle]
	mov	eax, [eax][MEMFILE.pos]
	ret
memtell endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	xor	eax, eax
	mov	ecx, [lpContext]
	push	[seh]
	mov	[ecx][CONTEXT.regEax], eax
	pop	[ecx][CONTEXT.regEip]
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	invoke	DestroyWindow, [mbp.hwndOwner]
	comcall	[IPicture.Release], [hPicLogo], eax
	comcall	[IStream.Release], [hStream], eax
	mov	eax, [hMemoryLogo]
	push	eax
	invoke	GlobalUnlock, eax
	call	GlobalFree
	mov	eax, [hBackMemory]
	push	eax
	invoke	GlobalUnlock, eax
	call	GlobalFree
	ddinvk	RestoreDisplayMode, [ddMain]
	ddsinvk	Release, [ddsPrimary]
	ddinvk	Release, [ddMain]
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start